%FreakLab - FreakLab_opt3.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Dieses Skript steuert das Bedienfeld 3 - Allgemeine komplexe Abbildung.
%
%Theorie:
%
%In FreakLab_opt2.m wird das Konzept der komplexen Abbildung erklrt und
%verwendet. Dieses Skript funktioniert im Prinzip gleich, nur das hier
%statt holomorphen Funktionen, die die Stetigkeit des Urbildes erhalten,
%hier in Formelzeilen beliebige komplexe Funktionen in Matlab-Syntax 
%eingegeben werden knnen, also auch nichtstetige. Das macht ist weniger
%anschaulich, jedoch nimmt die Vielfalt an erzielbaren Effekten erheblich
%zu.
%
%Die Formel setzt sich aus bis zu 9 Formelzeilen zusammen, zunchst ist nur
%eine Zeile vorhanden, je nach Bedarf knnen dann aber bis zu 8 weitere
%Zeilen erzeugt werden. Der Inhalt einer Zeile wird einfach nahtlos an die
%vordere Zeile angehngt. Das Handling der Zeilen funktioniert gleich wie
%das Handling der Summanden in FreakLab_opt2.m. Die Formelzeile wird rot
%hinterlegt, sobald bei der Ausfhrung der Gesamtformel ein Fehler
%auftritt. Wie man das Argument der Formel nennt, ist egal, wichtig ist
%nur, dass es nur einen Variablenname innerhalb der ganzen Formel gibt.
%Sobald eine gltige Formel eingegeben wurde erfolgt der Update des
%Preview-Bildes.
%
%Aus einem 'Formelbaukasten' knnen durch Klick Standardfunktionen am
%rechten Ende der Formel in der Zeile hinzugefgt werden. Die Zeile verfgt
%ber eine Sicherung gegen 'zu lang werden'.
%
%Auch hier knnen der Urbild- und der Bild-Zoomfaktor ber Slider und 
%Textboxen eingegeben werden. Ebenso kann auf ein Bild umgeschalten werden,
%das sich aus einem Urbild ergibt, das periodisch fortgesetzt wird
%(checkbox5)

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

%Diese Funktion bewirkt, dass das alle anderen Funktionen in diesem Skript 
%von aussen aufgerufen werden knnen in der Form: FreakLab_opt3('Funkname')
function varargout = FreakLab_opt3(varargin)

    func = str2func(varargin{1});
    
    if(nargout)
        
        [varargout{1:nargout}] = func(varargin{2:end});
        
    else
        
        func(varargin{2:end});
        
    end
    
end

%Aktion beim Einstellen der 'Urbild-Zoomstrke' ber den Slider
function slider8_Callback(hObject, eventdata, handles)

    inp = get(hObject,'Value');
    
    handles.uv = inp*1.5 + 0.5;
    
    set(handles.edit19,'String',num2str(handles.uv,'%1.2f'));
    
    disp_3_1(hObject,handles);
    
end

%Aktion beim Einstellen der 'Bild-Zoomstrke' ber den Slider
function slider9_Callback(hObject, eventdata, handles)

    inp = get(hObject,'Value');
    
    handles.xy = inp*1.5 + 0.5;
    
    set(handles.edit20,'String',num2str(handles.xy,'%1.2f'));
    
    disp_3_1(hObject,handles);
    
end

%Man beachte: Die Edit-Textfelder 19 und 20 wurden unter init mit der
%KeyPressFcn editupdate versehen. Diese bewirkt ein Update des
%Previews schon whrend der Eingabe (siehe editupdate.m)

%Aktion bei Eingabe der 'Urbild-Zoomstrke' ber das Textfeld
function edit19_Callback(hObject, eventdata, handles)

    inp = get(hObject,'String');
    len = length(inp);
    
    if(isempty(inp))
        
        set(hObject,'String',num2str(1,['%1.2f']));
    
    elseif(inp(end) ~= '.')
        
        len = len - (inp(1) == '-');

        inp = inpcheck(str2num(inp),1,0.5,2);
        
        handles.uv = inp;
        len = (len >= 3) + (len >= 4);
        
        set(handles.slider8,'Value',(inp - 0.5)/1.5);
        
        set(hObject,'String',num2str(inp,['%1.',num2str(len),'f']));
        
        disp_3_1(hObject,handles);
    
    end

end

%Aktion bei Eingabe der 'Bild-Zoomstrke' ber das Textfeld
function edit20_Callback(hObject, eventdata, handles)

    inp = get(hObject,'String');
    len = length(inp);
    
    if(isempty(inp))
        
        set(hObject,'String',num2str(1,['%1.2f']));
    
    
    elseif(inp(end) ~= '.')
        
        len = len - (inp(1) == '-');

        inp = inpcheck(str2num(inp),1,0.5,2);
        
        handles.xy = inp;
        len = (len >= 3) + (len >= 4);
        
        set(handles.slider9,'Value',(inp - 0.5)/1.5);
        
        set(hObject,'String',num2str(inp,['%1.',num2str(len),'f']));
        
        disp_3_1(hObject,handles);
    
    end

end

%Aktion beim Setzen der Checkbox fr periodische Fortsetzung
function checkbox5_Callback(hObject, eventdata, handles)

    handles.per = get(hObject,'Value');
    
    disp_3_1(hObject,handles);
    
end

%Aktion beim Klicken auf den Formelbausatz
function popupmenu2_Callback(hObject, eventdata, handles)

    %Bausatzelementnummer gewonnen
    val = get(hObject,'Value');
    
    %Bausatzelementstring gewonnen
    stri = get(hObject,'String');
    stri = stri(val);
    stri = cell2struct(stri,{'stri'},1);
    
    %Sind zumeist Funktionen von x, auer...
    stri = [' ',stri.stri,'(x) '];
    
    %... den arithmetischen Operationen
    if(val == 1)
        
        stri = ' + ';
        
    elseif(val == 2)
        
        stri = ' - ';
        
    elseif(val == 3)
        
        stri = ' * ';
        
    elseif(val == 4)
        
        stri = ' / ';
        
    elseif(val == 5)
        
        stri = ' ^ ';
        
    elseif(val == 7)
        
        stri = ' real(x) ';
        
    elseif(val == 8)
        
        stri = ' 1i*imag(x) ';
        
    end
    
    %Formel aus der Zeile gewinnen
    formel = get(handles.edit18,'String');
    
    %Nur falls die Sicherung gegen 'zu lang werden' (siehe press.m)
    %nicht Alarm schlgt, wird...
    if(~press(handles.edit18,handles))
        
        %...die Zeile um Bausatzelement erweitern
        set(handles.edit18,'String',[formel,stri]);
        %...den aktuellen Formelteil um Bausatzelement erweitern
        handles.holtra(handles.holtrac) = {[formel,stri]};
        
    end
    
    %Nach Einfgen des Bausatzelements soll der Eingabefokus wieder auf die
    %Formelzeile springen
    uicontrol(handles.edit18);
    
    %Darstelllen der modifizierten Formel
    disp_3_1(hObject,handles);
    
    guidata(hObject,handles);

end

%Aktion bei Eingabe einer Formel in das Formelzeilen-Textfeld
%Man beachte: Das Edit-Textfelder 18 wurden unter init mit der
%KeyPressFcn press versehen. Diese bewirkt die oben erwhnte
%Sicherung gegen 'zu lang werden' (siehe press.m)
function edit18_Callback(hObject, eventdata, handles)

    inp = get(hObject,'String');
    
    %Aktuellen Formelteil abspeichern
    handles.holtra(handles.holtrac) = {inp};
    
    disp_3_1(hObject,handles);
    
    guidata(hObject,handles);

end

%Aktion bei Auswahl der aktuell angezeigten Zeile
function popupmenu3_Callback(hObject, eventdata, handles)

    %Zeilennummer
    handles.holtrac = get(hObject,'Value');
    
    %Zeile gewinnen
    stri2 = handles.holtra(handles.holtrac);
    stri2 = cell2struct(stri2,{'stri2'},1);
    stri2 = stri2.stri2;
    
    %Anzeigen
    set(handles.edit18,'String',stri2);
    
    guidata(hObject,handles);

end

%Aktion beim Hinzufgen einer weiteren Zeile
function pushbutton9_Callback(hObject, eventdata, handles)

    set(handles.pushbutton10,'Enable','on');

    handles.trafos = handles.trafos + 1;

    stri = get(handles.popupmenu3,'String');
    stri = [stri;['Zeile ',num2str(handles.trafos)]];

    set(handles.popupmenu3,'String',stri);
        
    if(handles.trafos == 9)
        
        set(hObject,'Enable','off');
        
    end
    
    guidata(hObject,handles);

end

%Aktion beim Entfernen der letzten Zeile
function pushbutton10_Callback(hObject, eventdata, handles)

    set(handles.pushbutton9,'Enable','on');
    
    stri = get(handles.popupmenu3,'String');
    
    handles.holtrac = 1;
    
    set(handles.popupmenu3,'Value',1);
    
    stri2 = handles.holtra(handles.holtrac);
    stri2 = cell2struct(stri2,{'stri2'},1);
    stri2 = stri2.stri2;
    
    set(handles.edit18,'String',stri2);

    if(handles.trafos >= 2)
        
        stri = stri(1:(end-1),:);
        
        handles.holtra(handles.trafos) = {''};
        
        handles.trafos = handles.trafos - 1;
        
    end
    
    if(handles.trafos == 1)
        
        set(hObject,'Enable','off');
        
    end
    
    set(handles.popupmenu3,'String',stri);
    
    disp_3_1(hObject,handles);
    
    guidata(hObject,handles);

end
