%FreakLab - confirm.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Nachdem mithilfe von apply das transformierte Bild erzeugt wurde,
%dient diese Funktion, falls vom Benutzer gewnscht, zum bernehmen dieses
%Bildes.
%
%Die zuvor eingegebenen Spezifikationen der durchgefhrten Transformation
%werden nach dem bernehmen verworfen und mittels handleset durch Default
%-Werte ersetzt (im Gegensatz zu undo, dort bleiben diese erhalten).

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

%num gibt an, welches Bedienfeld gerade aktuell ist
function confirm(hObject,eventdata,handles,num)
    
    %Neues Bild wird auf die Haupt-Bildvariable geschrieben
    handles.image = handles.imnew;
    handles.imnew = 1;
    handles.imsize = size(handles.image);

    %Die bis hier abgearbeiteten Aktionen sind fr alle Bedienfeldnummer
    %gleich
    
    %Aktion fr Bedienfeld 1
    if(num == 1)
        
        handles.imtiny = imtransform(handles.imtiny,maketform('affine',[handles.afftra,zeros(2,1);zeros(1,2),1]));
        
    %Aktion fr Bedienfeld 2
    elseif(num == 2)

        uvdat = [-handles.uv,handles.uv];
        xydat = [-handles.xy,handles.xy];

        tform = tformgen(handles,1);
        
        handles.imtiny = imtransform(handles.imtiny,tform,'UData',uvdat,'VData',uvdat,'XData',xydat,'YData',xydat);
        
    %Aktion fr Bedienfeld 3
    elseif(num == 3)

        set(handles.edit18,'String',handles.holtra(1));
        
        uvdat = [-handles.uv,handles.uv];
        xydat = [-handles.xy,handles.xy];

        tform = tformgen(handles,2);

        handles.imtiny = imtransform(handles.imtiny,tform,'UData',uvdat,'VData',uvdat,'XData',xydat,'YData',xydat);
    
    %Aktion fr Bedienfeld 4
    elseif(num == 4)
        
        set(handles.edit21,'String',handles.holtra(1,1));
        
        handles.imtiny = imtransform_eigen(handles.imtiny(:,:,handles.colshift),handles);
    
    end
    
    %Die folgenden Aktionen sind wieder fr alle Bedienfeldnummer gleich

    %handles auffrischen
    handles = handleset(hObject,handles,num);
    %Bedienfeld wird fr eine neuerliche eingabe wieder aktiv geschalten
    disenable(hObject,handles,'on',num);
    
    guidata(hObject,handles);
    
end