%FreakLab - disp_3_1.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Diese Funktion dient in FreakLab_opt3 zum Update des Preview-Bildes
%(Display) bei nderung der Formel fr die Allgemeinen komplexen Funktion.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function disp_3_1(hObject,handles)

    %'Anwenden'-Button aktivieren, weil die Formel knnte nun funktionieren
    set(handles.pushbutton1,'Enable','On');
    
    %berprfe, ob Formel funktioniert
    try 
       
        %Entferne rote Hinterlegung des Eingabefeldes
        set(handles.edit18,'BackgroundColor',[1,1,1]);
        
        %Transformationsdaten generieren
        tform = tformgen(handles,2);
    
        %Bild- und Urbild-Zoomfaktoren gewinnen
        uvdat = [-handles.uv,handles.uv];
        xydat = [-handles.xy,handles.xy];

        %kleines Anzeigefenster auswhlen
        set(gcf,'CurrentAxes',handles.axes2);

        %Preview-Image mit Hilfe der Transformationsdaten berechnen und
        %anzeigen
        image(imtransform(handles.imtiny,tform,'UData',uvdat,'VData',uvdat,'XData',xydat,'YData',xydat));

        axis off;
        
    catch
        
        %Bei funktionierender Formel wird das Eingabefeld rot hinterlegt
        %und der 'Anwenden'-Button deaktiviert
        set(handles.edit18,'BackgroundColor',[1,0,0]);
        set(handles.pushbutton1,'Enable','Off');
        
    end
    
    guidata(hObject,handles);
    
end