%FreakLab - inpcheck.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Mit dieser Hilfsfunktion werden die in die Textfelder eingegebenen Zahlen
%auf Gltigkeit berprft und im Bedarfsfall korrigiert.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function val = inpcheck(val,stdval,minval,maxval)

    %Falls eingegebene Zahl leer, keine Fliekommazahl, nicht reel oder
    %kein Skalar ist...
    compl = (isempty(val) | ~isfloat(val) | ~isreal(val) | ~isscalar(val));
    
    %... wird sie durch einen Defaultwert ersetzt
    if(compl)
        
        val = stdval;
        
    %Falls sie zu gro ist, wird sie durch oberen Grenzwert ersetzt
    elseif(val >= maxval)
        
        val = maxval;
    
    %Falls sie zu klein ist, wird sie durch unteren Grenzwert ersetzt
    elseif(val <= minval)
        
        val = minval;
        
    end
    
end