%FreakLab - motion.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Diese Funktion ermittelt die Cursorposition ber dem Hauptanzeigefeld und
%zeigt diese Koordinaten im Programmfenster an (edit16 und edit17). Die
%Koordinaten werden desweiteren in der Variable handles.cpoint 
%abgespeichert, auf die getcenter.m zugreit, um bei Klick auf das 
%Bild eine komplexe Zahl im Intervall [-1,1],[-i,i] auszuwhlen, welche 
%in FreakLab_opt2.m als Nullstelle des aktuellen Polynoms verwendet wird.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function motion(hObject, eventdata, handles)

    %Koordinaten auslesen
    cpoint = get(handles.axes1,'CurrentPoint');
    cpoint = round(cpoint(1,1:2));
    
    %Wenn Koordinaten wirklich bergeben werden und zudem innerhalb der
    %Gre des darggestellten Bildes liegen, dann wurde sicher auf das Bild
    %geklickt und nicht auf einen anderen Punkt des Programmfensters...
    if(~isempty(handles.imname) & cpoint(1) >= 0 & cpoint(2) >= 0 & cpoint(1) <= handles.imsize(2) & cpoint(2) <= handles.imsize(1))
        
        %...erst in diesem Fall werden die Koordianten angezeigt...
        set(handles.edit16,'String',num2str(cpoint(1),'%1.0f'));
        set(handles.edit17,'String',num2str(cpoint(2),'%1.0f'));
        
        %...und in die Handle-Struktur geschrieben
        handles.cpoint = cpoint;
        guidata(hObject,handles);
        
    else

        %Ansonsten wird nichts angezeigt
        set(handles.edit16,'String','');
        set(handles.edit17,'String','');
        
    end
    
end